{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module DepGraph where {

import Show;
import Term;
import Util;
import ErrorMonad;
import Graph;
import Edg;
import List;

checkDepGraphProc ::
  forall a b.
    (Eq a, Sshow a, Eq b,
      Sshow b) => [(Term a b, Term a b)] ->
                    [(Bool, [(Term a b, Term a b)])] ->
                      [(Term a b, Term a b)] -> Eithera [[Char]] ();
checkDepGraphProc p dps r =
  catcha (checkDecomposition (checkEdgRM r) p dps)
    (\ x ->
      errora
        ("our estimation (EDG***) could not show that you gave a valid decomposition"
          : x));

}
